Save a bit of time: do not install RI and RDoc for the gems we install
[arvados.git] / jenkins / run-tests.sh
1 #!/bin/bash
2
3 # Install and test Arvados components.
4 #
5 # Exit non-zero if any tests fail.
6 #
7 # Arguments:
8 # --skip FOO     Do not test the FOO component.
9 # --only FOO     Do not test anything except the FOO component.
10 # envvar=value   Set $envvar to value
11 #
12 # Regardless of which components are tested, install all components in
13 # the usual sequence. (Many test suites depend on other components
14 # being installed.)
15 #
16 # To run a specific Ruby test, set $workbench_test, $apiserver_test or
17 # $cli_test on the command line:
18 #
19 # $ run-tests.sh --only workbench workbench_test=TEST=test/integration/pipeline_instances_test.rb
20 #
21 #
22 # To run a specific Python test set $python_sdk_test or $fuse_test.
23 #
24 # $ run-tests.sh --only python_sdk python_sdk_test="--test-suite tests.test_keep_locator"
25 #
26 #
27 # You can also pass "export ARVADOS_DEBUG=1" to enable additional debugging output:
28 #
29 # $ run-tests.sh "export ARVADOS_DEBUG=1"
30 #
31 #
32 # Finally, you can skip the installation steps on subsequent runs this way:
33 #
34 ## First run
35 # $ run-tests.sh --leave-temp
36 #
37 ## Subsequent runs: record the values of VENVDIR and GOPATH from the first run, and
38 # provide them on the command line in subsequent runs:
39 #
40 # $ run-tests.sh --skip-install VENVDIR="/tmp/tmp.y3tsTmigio" GOPATH="/tmp/tmp.3r4sSA9F3l"
41
42
43 # First make sure to remove any ARVADOS_ variables from the calling environment
44 # that could interfer with the tests.
45 unset $(env | cut -d= -f1 | grep \^ARVADOS_)
46
47 COLUMNS=80
48
49 export GOPATH=$(mktemp -d)
50 VENVDIR=$(mktemp -d)
51 cli_test=
52 workbench_test=
53 apiserver_test=
54 python_sdk_test=
55 ruby_sdk_test=
56 fuse_test=
57 leave_temp=
58 skip_install=
59
60 if [[ -f /etc/profile.d/rvm.sh ]]
61 then
62     source /etc/profile.d/rvm.sh
63 fi
64
65 fatal() {
66     clear_temp
67     echo >&2 "Fatal: $* in ${FUNCNAME[1]} at ${BASH_SOURCE[1]} line ${BASH_LINENO[0]}"
68     exit 1
69 }
70
71 # Sanity check
72 echo "WORKSPACE=$WORKSPACE"
73 [[ -n "$WORKSPACE" ]] || fatal "WORKSPACE not set"
74
75 # Set up temporary install dirs
76 mkdir -p "$GOPATH/src/git.curoverse.com"
77 ln -sfn "$WORKSPACE" "$GOPATH/src/git.curoverse.com/arvados.git" \
78     || fatal "symlink failed"
79
80 virtualenv --setuptools "$VENVDIR" || fatal "virtualenv $VENVDIR failed"
81 PATH="$VENVDIR/bin:$PATH"
82
83 declare -a failures
84 declare -A skip
85
86 # Always skip CLI tests. They don't know how to use run_test_server.py.
87 skip[cli]=1
88
89 while [[ -n "$1" ]]
90 do
91     arg="$1"; shift
92     case "$arg" in
93         --skip)
94             skipwhat="$1"; shift
95             skip[$skipwhat]=1
96             ;;
97         --only)
98             only="$1"; shift
99             ;;
100         --skip-install)
101             skip_install=1
102             ;;
103         --leave-temp)
104             leave_temp=1
105             ;;
106         *=*)
107             eval $(echo $arg | cut -d= -f1)=\"$(echo $arg | cut -d= -f2-)\"
108             ;;
109         *)
110             echo >&2 "$0: Unrecognized option: '$arg'"
111             exit 1
112             ;;
113     esac
114 done
115
116 checkexit() {
117     if [[ "$?" != "0" ]]; then
118         title "!!!!!! $1 FAILED !!!!!!"
119         failures+=("$1 (`timer`)")
120     else
121         successes+=("$1 (`timer`)")
122     fi
123 }
124
125 timer_reset() {
126     t0=$SECONDS
127 }
128
129 timer() {
130     echo -n "$(($SECONDS - $t0))s"
131 }
132
133 do_test() {
134     if [[ -z "${skip[$1]}" ]] && ( [[ -z "$only" ]] || [[ "$only" == "$1" ]] )
135     then
136         title "Running $1 tests"
137         timer_reset
138         if [[ "$2" == "go" ]]
139         then
140             go test "git.curoverse.com/arvados.git/$1"
141         else
142             "test_$1"
143         fi
144         checkexit "$1 tests"
145         title "End of $1 tests (`timer`)"
146     else
147         title "Skipping $1 tests"
148     fi
149 }
150
151 do_install() {
152     if [[ -z "$skip_install" ]]
153     then
154         title "Running $1 install"
155         timer_reset
156         if [[ "$2" == "go" ]]
157         then
158             go get -t "git.curoverse.com/arvados.git/$1"
159         else
160             "install_$1"
161         fi
162         checkexit "$1 install"
163         title "End of $1 install (`timer`)"
164     else
165         title "Skipping $1 install"
166     fi
167 }
168
169 title () {
170     txt="********** $1 **********"
171     printf "\n%*s%s\n\n" $((($COLUMNS-${#txt})/2)) "" "$txt"
172 }
173
174 clear_temp() {
175     if [[ -z "$leave_temp" ]]
176     then
177         for t in "$VENVDIR" "$GOPATH"
178         do
179             if [[ -n "$t" ]]
180             then
181                 rm -rf "$t"
182             fi
183         done
184     else
185         echo "Leaving VENVDIR=\"$VENVDIR\""
186         echo "Leaving GOPATH=\"$GOPATH\""
187     fi
188 }
189
190 test_docs() {
191     cd "$WORKSPACE/doc"
192     bundle install --no-deployment
193     rm -rf .site
194     # Make sure python-epydoc is installed or the next line won't do much good!
195     ARVADOS_API_HOST=qr1hi.arvadosapi.com
196     PYTHONPATH=$WORKSPACE/sdk/python/ bundle exec rake generate baseurl=file://$WORKSPACE/doc/.site/ arvados_workbench_host=workbench.$ARVADOS_API_HOST arvados_api_host=$ARVADOS_API_HOST
197     unset ARVADOS_API_HOST
198 }
199 do_test docs
200
201 test_doclinkchecker() {
202     cd "$WORKSPACE/doc"
203     bundle exec rake linkchecker baseurl=file://$WORKSPACE/doc/.site/
204 }
205 do_test doclinkchecker
206
207 test_ruby_sdk() {
208     cd "$WORKSPACE/sdk/ruby" \
209         && bundle install --no-deployment \
210         && bundle exec rake test
211 }
212 do_test ruby_sdk
213
214 install_ruby_sdk() {
215     cd "$WORKSPACE/sdk/ruby" \
216         && gem build arvados.gemspec \
217         && gem install --no-ri --no-rdoc arvados-*.gem
218 }
219 do_install ruby_sdk
220
221 install_cli() {
222     cd "$WORKSPACE/sdk/cli" \
223         && gem build arvados-cli.gemspec \
224         && gem install --no-ri --no-rdoc arvados-cli-*.gem
225 }
226 do_install cli
227
228 test_cli() {
229     title "Starting SDK CLI tests"
230     cd "$WORKSPACE/sdk/cli" \
231         && bundle install --no-deployment \
232         && mkdir -p /tmp/keep \
233         && KEEP_LOCAL_STORE=/tmp/keep bundle exec rake test $cli_test
234 }
235 do_test cli
236
237 install_apiserver() {
238     cd "$WORKSPACE/services/api"
239     bundle install --no-deployment
240
241     rm -f config/environments/test.rb
242     cp config/environments/test.rb.example config/environments/test.rb
243
244     cp $HOME/arvados-api-server/database.yml config/ || fatal "database.yml"
245     cp $HOME/arvados-api-server/application.yml config/ || fatal "application.yml"
246
247     # Fill in a random secret_token and blob_signing_key for testing
248     SECRET_TOKEN=`echo 'puts rand(2**512).to_s(36)' |ruby`
249     BLOB_SIGNING_KEY=`echo 'puts rand(2**512).to_s(36)' |ruby`
250
251     sed -i'' -e "s:SECRET_TOKEN:$SECRET_TOKEN:" config/application.yml
252     sed -i'' -e "s:BLOB_SIGNING_KEY:$BLOB_SIGNING_KEY:" config/application.yml
253
254     export RAILS_ENV=test
255
256     # Set up empty git repo (for git tests)
257     GITDIR="$WORKSPACE/tmpgit"
258     sed -i'' -e "s:/var/cache/git:$GITDIR:" config/application.default.yml
259
260     rm -rf $GITDIR
261     mkdir -p $GITDIR/test
262     cd $GITDIR/test \
263         && git init \
264         && git config user.email "jenkins@ci.curoverse.com" \
265         && git config user.name "Jenkins, CI" \
266         && touch tmp \
267         && git add tmp \
268         && git commit -m 'initial commit'
269
270     cd "$WORKSPACE/services/api" \
271         && bundle exec rake db:drop \
272         && bundle exec rake db:create \
273         && bundle exec rake db:setup
274 }
275 do_install apiserver
276
277 test_apiserver() {
278     cd "$WORKSPACE/services/api"
279     bundle exec rake test $apiserver_test
280 }
281 do_test apiserver
282
283 declare -a gostuff
284 gostuff=(
285     services/keepstore
286     services/keepproxy
287     sdk/go/arvadosclient
288     sdk/go/keepclient
289     sdk/go/streamer
290     )
291 for g in "${gostuff[@]}"
292 do
293     do_install "$g" go
294 done
295
296 install_python_sdk() {
297     # Install the Python SDK early. Various other test suites (like
298     # keepproxy) bring up run_test_server.py, which imports the arvados
299     # module. We can't actually *test* the Python SDK yet though, because
300     # its own test suite brings up some of those other programs (like
301     # keepproxy).
302
303     cd "$WORKSPACE/sdk/python" \
304         && python setup.py egg_info -b ".$(git log --format=format:%ct.%h -n1 .)" sdist rotate --keep=1 --match .tar.gz \
305         && pip install dist/arvados-python-client-0.1.*.tar.gz
306 }
307 do_install python_sdk
308
309 install_fuse() {
310     cd "$WORKSPACE/services/fuse" \
311         && python setup.py egg_info -b ".$(git log --format=format:%ct.%h -n1 .)" sdist rotate --keep=1 --match .tar.gz \
312         && pip install dist/arvados_fuse-0.1.*.tar.gz
313 }
314 do_install fuse
315
316 test_python_sdk() {
317     # Python SDK. We test this before testing keepproxy: keepproxy runs
318     # run_test_server.py, which depends on the yaml package, which is in
319     # tests_require but not install_requires, and therefore does not get
320     # installed by setuptools until we run "setup.py test" *and* install
321     # the .egg files that setup.py downloads.
322
323     cd "$WORKSPACE/sdk/python" \
324         && python setup.py test $python_sdk_test
325     r=$?
326     easy_install *.egg
327     return $r
328 }
329 do_test python_sdk
330
331 test_fuse() {
332     # Install test dependencies here too, in case run_test_server needs them.
333     cd "$WORKSPACE/services/fuse" \
334         && python setup.py test $fuse_test
335     r=$?
336     easy_install *.egg
337     return $r
338 }
339 do_test fuse
340
341 for g in "${gostuff[@]}"
342 do
343     do_test "$g" go
344 done
345
346 test_workbench() {
347     cd "$WORKSPACE/apps/workbench" \
348         && bundle install --no-deployment \
349         && bundle exec rake test $workbench_test
350 }
351 do_test workbench
352
353 clear_temp
354
355 for x in "${successes[@]}"
356 do
357     echo "Pass: $x"
358 done
359
360 if [[ ${#failures[@]} == 0 ]]
361 then
362     echo "All test suites passed."
363 else
364     echo "Failures (${#failures[@]}):"
365     for x in "${failures[@]}"
366     do
367         echo "Fail: $x"
368     done
369 fi
370 exit ${#failures}